#include "Init_I2C.h"
#include "stm32f0xx.h"
#include "stm32f0xx_gpio.h"

#define LCD_OWN_ADDRESS (0x27)  
//#define LCD_OWN_ADDRESS (0x3F)  
#define LCD_I2C_TIMEOUT					20000

uint16_t I2C_Timout = 0,Timeout = 0;

void Init_I2C(void)
{
   
      RCC->AHBENR |= RCC_AHBENR_GPIOAEN;
		
		RCC->APB1ENR |= RCC_APB1ENR_I2C1EN;
		RCC->CFGR3 |= RCC_CFGR3_I2C1SW; 
		
		//GPIOA->AFR[0] |= (1<<(4*0)) |(1<<(4*1));
		//  48  
//      GPIO_PinAFConfig(GPIOB, GPIO_PinSource6, GPIO_AF_5);//4
//      GPIO_PinAFConfig(GPIOB, GPIO_PinSource7, GPIO_AF_5);
//		GPIOB->MODER &= ~(GPIO_MODER_MODER6 |GPIO_MODER_MODER7);
//		GPIOB->MODER |= (GPIO_MODER_MODER6_1 |GPIO_MODER_MODER7_1);
//		GPIOB->OTYPER |=(GPIO_OTYPER_OT_6 |GPIO_OTYPER_OT_7);

		// 
      GPIO_PinAFConfig(GPIOA, GPIO_PinSource9, GPIO_AF_4);//5  48 
      GPIO_PinAFConfig(GPIOA, GPIO_PinSource10, GPIO_AF_4);
		GPIOA->MODER &= ~(GPIO_MODER_MODER9 |GPIO_MODER_MODER10);
		GPIOA->MODER |= (GPIO_MODER_MODER9_1 |GPIO_MODER_MODER10_1);
		GPIOA->OTYPER |=(GPIO_OTYPER_OT_9 |GPIO_OTYPER_OT_10);
   
		I2C1->TIMINGR = (uint32_t)0x00B01A3B;//0x00B01A4B; - 400   0x00700701 - 1.24 MHz
		I2C1->CR1 = I2C_CR1_PE; 
   

   
}

// 
void I2C_SendByte(unsigned char c)
{
//   TWDR = c;//    
//   TWCR = (1<<TWINT)|(1<<TWEN);//   
//   while (!(TWCR & (1<<TWINT)));//   TWIN
   
   I2C1->CR2 =  I2C_CR2_AUTOEND | (2<<16) | (LCD_OWN_ADDRESS<<1); 
   while ( (!(I2C1->ISR & I2C_ISR_TXE) ) && (Timeout == 0) )
   {
      I2C_Timout++;
      if (I2C_Timout == LCD_I2C_TIMEOUT) {I2C_Timout = 0;Timeout = 1; }
   };
   Timeout = 0;
   I2C_Timout = 0;
   I2C1->TXDR =(uint8_t) (c); /* Byte to send */
	 I2C1->CR2 |= I2C_CR2_START; /* Go */
   
}

// SLA_W +  
void I2C_SendPocket (unsigned char value,unsigned char adres_rw)
{
//I2C_StartCondition(); //   
//I2C_SendByte(adres_rw); //  + 
//I2C_SendByte(value);//  
//I2C_StopCondition();//  
}

